<?php

namespace Bluescale\Mail;

use Illuminate\Notifications\Notification;
use Psr\Http\Message\StreamInterface;

class BluescaleMailChannel
{
    protected $api;

    public function __construct(BluescaleMailApi $api)
    {
        $this->api = $api;
    }

    /**
     * @param $notifiable
     * @param Notification $notification
     * @return \Psr\Http\Message\StreamInterface
     * @throws BluescaleMailException
     */
    public function send($notifiable, Notification $notification): StreamInterface
    {
        $template = $notification->toTemplate($notifiable);

        return $this->api->send($template, $notifiable);
    }
}
